const init = require('../utils/init');

class ElmBaseClass {
	service_title;

	constructor() {
		const proto = Object.getPrototypeOf(this);
		const superProto = ElmBaseClass.prototype;
		const missing = Object.getOwnPropertyNames(superProto).find(
			name =>
				typeof superProto[name] === 'function' &&
				!proto.hasOwnProperty(name)
		);
		if (missing)
			throw new TypeError(
				`${this.constructor.name} needs to implement ${missing}`
			);
	}

	setServiceTitle(key, title) {
		this.service_title = {
			key: key,
			value: title
		};
	}

	async initialize() {
		init({ clear: true });
	}
}

module.exports = ElmBaseClass;
