const { prompt } = require('enquirer');
const data = require('./../utils/data');
const { yellow: y } = require('chalk');
const alert = require('cli-alerts');
const Helper = require('../utils/helpers');
const event = require('../utils/event');

const addUserInfo = async () => {
	const userInfo = await prompt([
		{
			type: 'input',
			name: 'name',
			message: 'Enter your name',
			initial: '',
			validate: Helper.getValidate()
		},
		{
			type: 'input',
			name: 'email',
			message: 'Enter your elm email',
			initial: '',
			validate: Helper.getValidate()
		},
		{
			type: 'input',
			name: 'password',
			message: 'Enter your API Token',
			initial: '',
			validate: Helper.getValidate()
		}
	]);
	const user = await data.addUser(userInfo);
	if (user) {
		return {
			success: true,
			action: event.mainUserAdded,
			message: `User ${user.name} added successfully`
		};
	} else {
		alert({
			type: 'error',
			msg: `User ${user.name} not added`
		});
		await addUserInfo();
	}
};

module.exports = {
	addUserInfo
};
